;WINDOWS V3.3

;---------------------------------------

w_ptr    = 2
sptr     = w_ptr+2
stptr    = sptr+2
colptr   = stptr+2
chrptr   = colptr+2

;---------------------------------------

winit    jmp w_init
wopen    jmp w_open
wclose   jmp w_close
wchoose  jmp w_select
stoflow  jmp $f445
stuflow  jmp $f445
allclosd jmp $f445

;---------------------------------------

w_getkey   jmp $ffe4

space    .byte $20
return   .byte $0d
cru      .byte $91
crd      .byte $11
crl      .byte $9d
crr      .byte $1d
esc      .byte $1b

;---------------------------------------

w_init     and #$f8
         sta screen

         stx stbot
         sty sttop

         lda #0
         sta sptr
         stx sptr+1
         sta selected
         rts

;---------------------------------------

w_open     sta w_ptr
         stx w_ptr+1

         lda sptr
         pha
         lda sptr+1
         pha

         lda wadr
         jsr push
         lda wadr+1
         jsr push

         lda selected
         jsr push
         lda #0
         sta selected

         lda lastwint
         jsr push
         lda curwint
         sta lastwint

         lda w_ptr
         ldx w_ptr+1
         sta wadr
         stx wadr+1

         jsr windread

         lda number
         asl a
         asl a
         adc number
         adc #7
         adc w_ptr
         sta w_ptr
         bcc +
         inc w_ptr+1

+         lda xpos
         sta col
         lda ypos
         sta row
         lda heigth
         sta temp

o1       jsr adrclc

         ldy #0

o0       lda (colptr),y
         jsr push
         lda (chrptr),y
         jsr push

         lda color
         sta (colptr),y
         jsr read
         sta (chrptr),y

         iny
         cpy width
         bne o0

         tya
         clc
         adc w_ptr
         sta w_ptr
         bcc +
         inc w_ptr+1

+         inc row
         dec temp
         bne o1

         pla
         jsr push
         pla
         jmp push

;---------------------------------------

w_close    jsr pull
         tay
         jsr pull
         sty sptr
         sta sptr+1
         sty stptr
         sta stptr+1

         jsr pul
         sta wadr
         jsr pul
         sta wadr+1

         jsr pul
         sta selected
         jsr pul
         sta lastwint

         lda xpos
         sta col
         lda ypos
         sta row
         lda heigth
         sta temp

c1       jsr adrclc

         ldy #0

c0       jsr pul
         sta (colptr),y
         jsr pul
         sta (chrptr),y

         iny
         cpy width
         bne c0

         inc row
         dec temp
         bne c1

;---------------------------------------

windread lda wadr
         ldx wadr+1
         sta w_ptr
         stx w_ptr+1
         ldy #0
wdr0     jsr read
         sta windatas,y
         iny
         cpy #7
         bne wdr0
         rts

;---------------------------------------

w_select lda #0
         cmp sptr
         lda stbot
         sbc sptr+1
         bne *+5

         jmp allclosd

;--------

+	lda number
	bne +

-	jsr w_getkey
	beq -

         jmp esc0

;--------

+      cmp #1
         bne s0

         jsr click
         jsr w_close
         jmp w_select

;--------

s0       jsr barout

s1       jsr w_getkey

         cmp space
         beq cl0
         cmp return
         bne +

cl0      jmp click

+         cmp cru
         beq up

         cmp crl
         beq left

         cmp crd
         beq down

         cmp crr
         beq right

         cmp esc
         bne s1

;--------

escape   lda curwint
         and #16
         beq s1

esc0     jsr w_close

         lda #0
         cmp sptr
         lda stbot
         sbc sptr+1
         bne s1

         jmp allclosd

;--------

up       lda curwint
         and #2
         bne sdc

         lda lastwint
         and #8
         bne sdl

         jmp s1

;--------

left     lda curwint
         and #1
         bne sdc

         lda lastwint
         and #4
         bne sdl

         jmp s1

sdc      jsr barout

         lda selected
         bne sdc0

         lda number
         sta selected

sdc0     dec selected

         jmp s0

sdl      jsr w_close

         jsr barout

         lda selected
         bne sdl0

         lda number
         sta selected

sdl0     dec selected

         jmp sil0

;--------

down     lda curwint
         and #2
         bne sic

         lda lastwint
         and #8
         bne sil

         jmp s1

right    lda curwint
         and #1
         bne sic

         lda lastwint
         and #4
         bne sil

         jmp s1

sic      jsr barout

         inc selected
         lda selected
         cmp number
         bne sic0

         lda #0
         sta selected

sic0     jmp s0

sil      jsr w_close

         jsr barout

         inc selected
         lda selected
         cmp number
         bne sil0

         lda #0
         sta selected

sil0     jsr barout

         lda number
         asl a
         adc selected
         tay
         jsr read

         beq +

         jmp s1

;--------
+
click    lda number
         asl a
         adc #7
         adc wadr
         sta w_ptr
         lda #0
         adc wadr+1
         sta w_ptr+1

         lda selected
         asl a
         adc number
         tay

         jsr read
         sta stptr
         iny
         jsr read
         sta stptr+1

         ldy selected
         jsr read
         beq submenu

         jsr cl1
         jmp s1
         
cl1      jmp (stptr)

;--------

submenu  lda stptr
         ldx stptr+1
         jsr w_open

         jmp w_select

;---------------------------------------

read     php
         sei

         lda $ff13
         and #1
         pha

         sta $ff3f

         lda (w_ptr),y
         sta rtemp

         pla
         beq +

         sta $ff3e

+         plp
         lda rtemp
         rts

;---------------------------------------

push     pha
         lda sptr+1
         cmp sttop
         bne +

         jmp stoflow

+         pla

         sty sttemp
         ldy #0

         sta (sptr),y

         inc sptr
         bne push1
         inc sptr+1

push1    ldy sttemp
         rts

;---------------------------------------

pull     lda sptr
         bne +
         dec sptr+1
+         dec sptr

         lda sptr+1
         cmp stbot
         bcs +

         jmp stuflow

+         php
         sei

         lda $ff13
         and #1
         pha

         sta $ff3f

         sty sttemp
         ldy #0

         lda (sptr),y
         sta rtemp

         pla
         beq +

         sta $ff3e
+
pull2    plp

         ldy sttemp
         lda rtemp
         rts

;---------------------------------------

pul      php
         sei

         lda $ff13
         and #1
         pha

         sta $ff3f

         sty sttemp
         ldy #0

         lda (stptr),y
         sta rtemp

         pla
         beq +

         sta $ff3e

+         inc stptr
         bne +
         inc stptr+1

+         plp

         ldy sttemp
         lda rtemp
         rts

;---------------------------------------

adrclc   ldx row

         lda col
         clc
         adc scrlo,x

         sta colptr
         sta chrptr

         lda screen
         adc scrhi,x

         sta colptr+1

         ora #4
         sta chrptr+1
         rts

;---------------------------------------

barout   lda wadr
         clc
         adc #7
         sta w_ptr
         lda wadr+1
         adc #0
         sta w_ptr+1

         lda selected
         asl a

         tay
         jsr read
         clc
         adc xpos
         sta col

         iny
         jsr read
         clc
         adc ypos
         sta row

         jsr adrclc

         ldx #2
         ldy #0

bo0      lda (colptr),y
         eor #$20
         sta (colptr),y

         lda (chrptr),y

         iny

         and #$7f
         cmp #$20
         bne bo0

         dex
         bne bo0
         rts

;---------------------------------------

sttemp   .byte 0
temp     .byte 0
rtemp    .byte 0

stbot    .byte 0
sttop    .byte 0

wadr     .word 0

windatas
xpos     .byte 0
ypos     .byte 0
width    .byte 0
heigth   .byte 0
color    .byte 0
number   .byte 0
curwint  .byte 0

lastwint .byte 0
selected .byte 0

col      .byte 0
row      .byte 0

screen   .byte 8

scrlo    .byte $00,$28,$50,$78,$a0,$c8
         .byte $f0,$18,$40,$68,$90,$b8
         .byte $e0,$08,$30,$58,$80,$a8
         .byte $d0,$f8,$20,$48,$70,$98
         .byte $c0
scrhi    .byte $00,$00,$00,$00,$00,$00
         .byte $00,$01,$01,$01,$01,$01
         .byte $01,$02,$02,$02,$02,$02
         .byte $02,$02,$03,$03,$03,$03
         .byte $03

;---------------------------------------
; Routines     Parameters
;---------------------------------------
; 1000 w_init    A:ScrAddr,X:StBot,Y:StTop
; 1003 w_open    A/X:Windowaddress
; 1006 w_close   none
; 1009 w_select  none
; 100c StOFlow -
; 100f StUFlow -
; 1012 AllClsd -
; 1015 w_GetKey  -
; 1018 Space   code
; 1019 Return  code
; 101a Up      code
; 101b Down    code
; 101c Left    code
; 101d Right   code
; 101e Escape  code
;---------------------------------------
; The routines where the parameters are
;  "-" are internally called by Windows.
;  You must change these vectors to
;  point at your ownn routines.
;---------------------------------------
; The fields where "code" is specified
;  as parameters are only the codes of
;  the keys returned by GetKey
;---------------------------------------
;
; Window definiton:
;---------------------------------------
; 0: XPos
; 1: YPos
; 2: Width
; 3: Heigth
; 4: Color
; 5: Number
; 6: WinType
; 7: Number * 2 bytes:
;      0: XPos of MenuItem
;      1: YPos of MenuItem
;    Number bytes:
;      MenuItemType:
;        0: SubMenu
;        1: SubRoutine
;    Number words:
;      MenuItemAddress
;    WindowDefiniton
;---------------------------------------
;
; Notes:
;---------------------------------------
; About the Number of MenuItems:
;    0: Opens Window, waits for Keypress
;       and closes
;    1: Opens Window and Selects that
;       item
; more: You can select from the items.
;
; About the WinType:
;   b0: Horizontal selection when active
;   b1: Vertical selection when active
;   b2: Horizontal selection when inact.
;   b3: Vertical selection when inactive
;   b4: Enable Escape
